#include "HexBoard.h"
#include <stdlib.h>
#include <stdio.h>
#include <time.h>
#include <string.h>

HexBoard * Board;

void InitTantrix(int boardSizeX, int boardSizeY, char * tilesToUse) {
	//Board = new HexBoard(boardSizeX, boardSizeY, ALL_TILES);
	Board = new HexBoard(boardSizeX, boardSizeY, tilesToUse);
	
}

// A board initialisation function - places random tiles at
// random orientations on the board.
void init_Random() {
	int x, y, t, o, p;
	
	// Fill a list with our available tiles		
	int * L = (int *) calloc(sizeof(int), MAX_TILES);
	int lSize = 0;
	
	// Generate a list of the tiles we have
	for (t=0; t<Board->Tiles->numTiles; t++) {
		L[lSize] = t;
		lSize++;
	}
	
	// Place random tiles at each position on the board
	for (x=0; x<Board->sizeX; x++) {
		for (y=0; y<Board->sizeY; y++) {
			
			// Pick random tile and orientation
			p=0;//p = random() % L.size();
			o = random() % 6;
			
			// Place tile in position
			t =  L[p];

			// Place the tile				
			Board->PlaceTile(t, o, x, y);
			
			// Record that it is no longer available in our list
			lSize--;
			L[p]=L[lSize];
			
		}
	}
	
	free(L);
}

int solve(int loopColour) {
	int x1, y1, x2, y2, t1, t2;
	int o1, o2;
	int move=0;
	
   // Place tiles randomly
   init_Random();

   // Initialise the violation matrix
   Board->CountViolations();


   while (Board->violations.total>0 && move < TIME_OUT) {
		// Pick a random tile in conflict
		t1 = Board->conflict[random() % Board->numInConflict];
		
		// Get <x, y> for this tile
		x1 = t1 / Board->sizeY;
		y1 = t1 % Board->sizeY;

		// Pick a random second tile
		x2 = random() % Board->sizeX;
		y2 = random() % Board->sizeY;
		
		// Pick random new orientations
		o1 = random() % 6;
		o2 = random() % 6;

		Board->SwapTiles(x1, y1, x2, y2, o1, o2);
		
		move++;
		printf("Move: %d, Violations: %d\n", move, Board->violations.total);
		Board->DumpBoard();
   }
   
	return Board->violations.total;

}

int main(int argc, char * argv[]) {

	char tilesToUse[MAX_TILES+1];
	
	int loopColour;
	if (argc<3) {
		printf("tantrix LOOP_COLOUR BIG_56_CHARACTER_LONG_TILES_TO_USE_STRING\n");
		exit(1);
	}
	loopColour = atoi(argv[1]);

	// Sample tile strings	
//	strcpy(tilesToUse, "YYYYYYYYYYYYYYNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNN");
//	strcpy(tilesToUse, "YYYYNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNN");
	strcpy(tilesToUse, argv[2]);

   InitTantrix(2, 2, tilesToUse);
   srandom(time(NULL));
   for (int i=0; i<1; i++) printf("Run %d = %d\n", i, solve(loopColour));
}

