#include "Define.h"
#include "TileSet.h"
#include <stdio.h>
#include <string.h>

TileSet::TileSet(char * tilesToUse) {

	int numCurrentTiles=0;
	int setNumber = ALL_TILES;
	
	numTiles = 0;
	
	printf("Using tileset(%d)\n", setNumber);

	if ((setNumber&NO_BLUE_TILES)>0) {
		numTiles+=14;
	}
	
	if ((setNumber&NO_RED_TILES)>0) {
		numTiles+=14;
	}

	if ((setNumber&NO_GREEN_TILES)>0) {
		numTiles+=14;
	} 

	if ((setNumber&NO_YELLOW_TILES)>0) {
		numTiles+=14;
	}

	if ((setNumber&NO_BLUE_TILES)>0) {
		if (tilesToUse[0]=='Y') { strcpy(TileDesc[numCurrentTiles], "GGRRYY"); TileNames[numCurrentTiles++]=1; }
		if (tilesToUse[1]=='Y') { strcpy(TileDesc[numCurrentTiles], "GGYYRR"); TileNames[numCurrentTiles++]=2; }
		if (tilesToUse[2]=='Y') { strcpy(TileDesc[numCurrentTiles], "GGYRRY"); TileNames[numCurrentTiles++]=3; }
		if (tilesToUse[3]=='Y') { strcpy(TileDesc[numCurrentTiles], "RRGYYG"); TileNames[numCurrentTiles++]=4; }
		if (tilesToUse[4]=='Y') { strcpy(TileDesc[numCurrentTiles], "GGRYYR"); TileNames[numCurrentTiles++]=5; }
		if (tilesToUse[5]=='Y') { strcpy(TileDesc[numCurrentTiles], "YGRYRG"); TileNames[numCurrentTiles++]=6; }
		if (tilesToUse[6]=='Y') { strcpy(TileDesc[numCurrentTiles], "GRYGYR"); TileNames[numCurrentTiles++]=7; }
		if (tilesToUse[7]=='Y') { strcpy(TileDesc[numCurrentTiles], "RGYRYG"); TileNames[numCurrentTiles++]=8; }
		if (tilesToUse[8]=='Y') { strcpy(TileDesc[numCurrentTiles], "YYRGRG"); TileNames[numCurrentTiles++]=9; }
		if (tilesToUse[9]=='Y') { strcpy(TileDesc[numCurrentTiles], "YYGRGR"); TileNames[numCurrentTiles++]=10; }
		if (tilesToUse[10]=='Y') { strcpy(TileDesc[numCurrentTiles], "GGRYRY"); TileNames[numCurrentTiles++]=11; }
		if (tilesToUse[11]=='Y') { strcpy(TileDesc[numCurrentTiles], "GGYRYR"); TileNames[numCurrentTiles++]=12; }
		if (tilesToUse[12]=='Y') { strcpy(TileDesc[numCurrentTiles], "RRGYGY"); TileNames[numCurrentTiles++]=13; }
		if (tilesToUse[13]=='Y') { strcpy(TileDesc[numCurrentTiles], "RRYGYG"); TileNames[numCurrentTiles++]=14; }
	}

	if ((setNumber&NO_RED_TILES)>0) {
		if (tilesToUse[14]=='Y') { strcpy(TileDesc[numCurrentTiles], "BBYYGG"); TileNames[numCurrentTiles++]=15; }
		if (tilesToUse[15]=='Y') { strcpy(TileDesc[numCurrentTiles], "BBGGYY"); TileNames[numCurrentTiles++]=16; }
		if (tilesToUse[16]=='Y') { strcpy(TileDesc[numCurrentTiles], "BBYGGY"); TileNames[numCurrentTiles++]=17; }
		if (tilesToUse[17]=='Y') { strcpy(TileDesc[numCurrentTiles], "BBGYYG"); TileNames[numCurrentTiles++]=18; }
		if (tilesToUse[18]=='Y') { strcpy(TileDesc[numCurrentTiles], "GGBYYB"); TileNames[numCurrentTiles++]=19; }
		if (tilesToUse[19]=='Y') { strcpy(TileDesc[numCurrentTiles], "YBGYGB"); TileNames[numCurrentTiles++]=20; }
		if (tilesToUse[20]=='Y') { strcpy(TileDesc[numCurrentTiles], "GBYGYB"); TileNames[numCurrentTiles++]=21; }
		if (tilesToUse[21]=='Y') { strcpy(TileDesc[numCurrentTiles], "BGYBYG"); TileNames[numCurrentTiles++]=22; }
		if (tilesToUse[22]=='Y') { strcpy(TileDesc[numCurrentTiles], "YYBGBG"); TileNames[numCurrentTiles++]=23; }
		if (tilesToUse[23]=='Y') { strcpy(TileDesc[numCurrentTiles], "YYGBGB"); TileNames[numCurrentTiles++]=24; }
		if (tilesToUse[24]=='Y') { strcpy(TileDesc[numCurrentTiles], "GGBYBY"); TileNames[numCurrentTiles++]=25; }
		if (tilesToUse[25]=='Y') { strcpy(TileDesc[numCurrentTiles], "GGYBYB"); TileNames[numCurrentTiles++]=26; }
		if (tilesToUse[26]=='Y') { strcpy(TileDesc[numCurrentTiles], "BBGYGY"); TileNames[numCurrentTiles++]=27; }
		if (tilesToUse[27]=='Y') { strcpy(TileDesc[numCurrentTiles], "BBYGYG"); TileNames[numCurrentTiles++]=28; }
	}

	if ((setNumber&NO_GREEN_TILES)>0) {
		if (tilesToUse[28]=='Y') { strcpy(TileDesc[numCurrentTiles], "BBYYRR"); TileNames[numCurrentTiles++]=29; }
		if (tilesToUse[29]=='Y') { strcpy(TileDesc[numCurrentTiles], "BBRRYY"); TileNames[numCurrentTiles++]=30; }
		if (tilesToUse[30]=='Y') { strcpy(TileDesc[numCurrentTiles], "BBYRRY"); TileNames[numCurrentTiles++]=31; }
		if (tilesToUse[31]=='Y') { strcpy(TileDesc[numCurrentTiles], "BBRYYR"); TileNames[numCurrentTiles++]=32; }
		if (tilesToUse[32]=='Y') { strcpy(TileDesc[numCurrentTiles], "RRBYYB"); TileNames[numCurrentTiles++]=33; }
		if (tilesToUse[33]=='Y') { strcpy(TileDesc[numCurrentTiles], "YBRYRB"); TileNames[numCurrentTiles++]=34; }
		if (tilesToUse[34]=='Y') { strcpy(TileDesc[numCurrentTiles], "RBYRYB"); TileNames[numCurrentTiles++]=35; }
		if (tilesToUse[35]=='Y') { strcpy(TileDesc[numCurrentTiles], "BRYBYR"); TileNames[numCurrentTiles++]=36; }
		if (tilesToUse[36]=='Y') { strcpy(TileDesc[numCurrentTiles], "YYBRBR"); TileNames[numCurrentTiles++]=37; }
		if (tilesToUse[37]=='Y') { strcpy(TileDesc[numCurrentTiles], "YYRBRB"); TileNames[numCurrentTiles++]=38; }
		if (tilesToUse[38]=='Y') { strcpy(TileDesc[numCurrentTiles], "RRBYBY"); TileNames[numCurrentTiles++]=39; }
		if (tilesToUse[39]=='Y') { strcpy(TileDesc[numCurrentTiles], "RRYBYB"); TileNames[numCurrentTiles++]=40; }
		if (tilesToUse[40]=='Y') { strcpy(TileDesc[numCurrentTiles], "BBRYRY"); TileNames[numCurrentTiles++]=41; }
		if (tilesToUse[41]=='Y') { strcpy(TileDesc[numCurrentTiles], "BBYRYR"); TileNames[numCurrentTiles++]=42; }
	} 

	if ((setNumber&NO_YELLOW_TILES)>0) {
		if (tilesToUse[42]=='Y') { strcpy(TileDesc[numCurrentTiles], "BBGGRR"); TileNames[numCurrentTiles++]=43; }
		if (tilesToUse[43]=='Y') { strcpy(TileDesc[numCurrentTiles], "BBRRGG"); TileNames[numCurrentTiles++]=44; }
		if (tilesToUse[44]=='Y') { strcpy(TileDesc[numCurrentTiles], "BBGRRG"); TileNames[numCurrentTiles++]=45; }
		if (tilesToUse[45]=='Y') { strcpy(TileDesc[numCurrentTiles], "BBRGGR"); TileNames[numCurrentTiles++]=46; }
		if (tilesToUse[46]=='Y') { strcpy(TileDesc[numCurrentTiles], "GGBRRB"); TileNames[numCurrentTiles++]=47; }
		if (tilesToUse[47]=='Y') { strcpy(TileDesc[numCurrentTiles], "GBRGRB"); TileNames[numCurrentTiles++]=48; }
		if (tilesToUse[48]=='Y') { strcpy(TileDesc[numCurrentTiles], "RBGRGB"); TileNames[numCurrentTiles++]=49; }
		if (tilesToUse[49]=='Y') { strcpy(TileDesc[numCurrentTiles], "BGRBRG"); TileNames[numCurrentTiles++]=50; }
		if (tilesToUse[50]=='Y') { strcpy(TileDesc[numCurrentTiles], "GGBRBR"); TileNames[numCurrentTiles++]=51; }
		if (tilesToUse[51]=='Y') { strcpy(TileDesc[numCurrentTiles], "GGRBRB"); TileNames[numCurrentTiles++]=52; }
		if (tilesToUse[52]=='Y') { strcpy(TileDesc[numCurrentTiles], "RRBGBG"); TileNames[numCurrentTiles++]=53; }
		if (tilesToUse[53]=='Y') { strcpy(TileDesc[numCurrentTiles], "RRGBGB"); TileNames[numCurrentTiles++]=54; }
		if (tilesToUse[54]=='Y') { strcpy(TileDesc[numCurrentTiles], "BBRGRG"); TileNames[numCurrentTiles++]=55; }
		if (tilesToUse[55]=='Y') { strcpy(TileDesc[numCurrentTiles], "BBGRGR"); TileNames[numCurrentTiles++]=56; }
	}

	numTiles = numCurrentTiles;
}

// Displays a tile to the screen
void TileSet::displayTile(int tileNumber) {
	//printf("%d %d\n", tileNumber, numTiles);
	if (tileNumber < numTiles) printf("%s", TileDesc[tileNumber]);
}


